import arcade
import math

COMPR = 100
F_COMPR = 0.9
D_ANG = 35
ORDEM = 5

def legenda(arcade, x, y, x1, y1, texto, cor):
    xt = (x + x1)/2
    yt = (y + y1)/2
    arcade.draw_text(
        text = texto,
        start_x = xt, start_y = yt,
        font_name = 'Courier New', font_size = 14,
        anchor_y = 'top',
        color = cor)
    arcade.draw_circle_filled(
        xt, yt,
        3, arcade.color.BLACK)

def ramo(arcade, x, y, compr, ang, ordem):
     global recur
     ang_rad = ang*math.pi/180
     x1 = x + compr*math.cos(ang_rad)
     y1 = y + compr*math.sin(ang_rad)
     # desenha o ramo
     arcade.draw_line(x, y, x1, y1,
          arcade.color.BLACK)
     recur += 1
     legenda(arcade,
          x, y, x1, y1, str(recur),
          arcade.color.BLUE)

     # bifurca ou eh ramo terminal?
     if ordem > 1:
          compr *= F_COMPR
          ramo(arcade, x1, y1,
               compr, ang + D_ANG,
               ordem - 1)
          ramo(arcade, x1, y1,
               compr, ang - D_ANG,
               ordem - 1)
    
# tamanho da janela que vamos usar
LARG_TELA = 800
ALT_TELA = 600
# nome da janela
TIT_TELA = 'Arvore'

# cria janela com dimensoes
arcade.open_window(LARG_TELA, ALT_TELA, TIT_TELA)
# define cor de fundo da tela
arcade.set_background_color(arcade.color.WHITE)
# apaga a tela e comeca a desenhar
arcade.start_render()

x = LARG_TELA / 2
y = 0
ang = 90
recur = 0

ramo(arcade,
     x, 0,
     COMPR, ang,
     ORDEM)

# termina de desenhar e mostra a tela
arcade.finish_render()
# espera usuario fechar a janela
arcade.run()
