import arcade
import random

# velocidade maxima e raio maximo da bola
V_X_BOLA = 5
V_Y_BOLA = 5
MAX_RAIO_BOLA = 30

# tamanho e titulo da janela que vamos usar
LARG_TELA = 400
ALT_TELA = 300
TIT_TELA = 'Bolinha'

class Bola:
    def __init__(self):
        # coordenada inicial da bola
        self.x = random.randint(0, LARG_TELA)
        self.y = random.randint(0, ALT_TELA)
        # velocidade
        self.v_x = random.randint(1,V_X_BOLA)
        self.v_y = random.randint(1,V_Y_BOLA)        
        # raio da bola
        self.raio = random.randint(1,MAX_RAIO_BOLA)
        # cor
        r = random.randint(0,255)
        g = random.randint(0,255)
        b = random.randint(0,255)
        self.cor = (r,g,b)

    def move(self):
        self.x += self.v_x
        self.y += self.v_y
        
        if self.x < 0 or self.x > LARG_TELA:
            self.v_x = -self.v_x
        
        if self.y < 0 or self.y > ALT_TELA:
            self.v_y = -self.v_y  

    def desenha(self, arcade):
        arcade.draw_circle_filled(
            self.x, self.y,
            self.raio, self.cor)

class MeuJogo(arcade.Window):
    def __init__(self):
        super().__init__(LARG_TELA, ALT_TELA,
            TIT_TELA)
        arcade.set_background_color(
            arcade.color.WHITE)
        self.bola_list = []
        bola = Bola()
        self.bola_list.append(bola)

    def on_update(self, delta_time):
        for bola in self.bola_list:
            bola.move()
    
    def on_draw(self):
        arcade.start_render()
        for bola in self.bola_list:
            bola.desenha(arcade)

    def on_key_press(self, key, modifiers):
        if key == arcade.key.SPACE:
            bola = Bola()
            self.bola_list.append(bola)

def main():
    window = MeuJogo()
    arcade.run()

if __name__ == "__main__":
    main()
