"""
Arte proveniente do http://kenney.nl
"""

import arcade
import random
import math
import os

# velocidade maxima e escala da bola
V_BOLA = 5
MIN_ESCALA = 0.2
MAX_ESCALA = 0.8

# tamanho e titulo da janela que vamos usar
LARG_TELA = 400
ALT_TELA = 300
TIT_TELA = 'Bolinha'

class BolaSprite(arcade.Sprite):
    def __init__(self):
        arq = 'platformer-pack-redux-360-assets'\
            '/PNG/Items/coinGold.png'
        rnd = random.random()
        esc = rnd*(MAX_ESCALA - MIN_ESCALA)\
            + MIN_ESCALA
        super().__init__(arq, esc)

        # coordenada inicial do sprite
        self.center_x = random.randint(0, LARG_TELA)
        self.center_y = random.randint(0, ALT_TELA)
        # velocidade
        theta_graus = random.randint(0,60) * 6
        theta_rad = theta_graus*math.pi/180
        self.change_x = V_BOLA*math.cos(theta_rad)
        self.change_y = V_BOLA*math.sin(theta_rad)
        
    def update(self):
        if self.center_x < 0 or\
                self.center_x > LARG_TELA:
            self.change_x = -self.change_x        
        if self.center_y < 0 or\
                self.center_y > ALT_TELA:
            self.change_y = -self.change_y  
        # chama a superclasse
        super().update()

class MeuJogo(arcade.Window):
    def __init__(self):
        super().__init__(LARG_TELA, ALT_TELA,
            TIT_TELA)           
        # muda o diretorio corrente para o mesmo
        # diretorio que esta o fonte .py
        file_path = os.path.dirname(
            os.path.abspath(__file__))
        os.chdir(file_path)
    
        arcade.set_background_color(
            arcade.color.WHITE)
        self.bola_list = arcade.SpriteList()
        bola = BolaSprite()
        self.bola_list.append(bola)

    def on_update(self, delta_time):
        self.bola_list.update()
    
    def on_draw(self):
        arcade.start_render()
        self.bola_list.draw()

    def on_key_press(self, key, modifiers):
        if key == arcade.key.SPACE:
            bola = BolaSprite()
            self.bola_list.append(bola)

def main():
    window = MeuJogo()
    arcade.run()

if __name__ == "__main__":
    main()
