
# modulo 04, ex 01
import arcade
import math

# raio dos ponteiros
R_HOR = 60
R_SEG = 90
R_MIN = 90
# espessura dos ponteiros
E_HOR = 20
E_MIN = 10
E_SEG = 1
# cor do ponteiros
C_HOR = arcade.color.WHITE
C_MIN = arcade.color.WHITE
C_SEG = arcade.color.RED

# FPS do relogio
FPS_RELOGIO = 5

# tamanho e titulo da janela que vamos usar
LARG_TELA = 600
ALT_TELA = 600
TIT_TELA = 'Relogio'

class Relogio(arcade.Window):
    def __init__(self):
        super().__init__(LARG_TELA, ALT_TELA,
            TIT_TELA)
        arcade.set_background_color(
            arcade.color.BLACK)
        # FPS
        self.set_update_rate(1/FPS_RELOGIO)
        # incremento do ponteiro dos segundos [s]
        self.delta_seg = 1/FPS_RELOGIO

        # raio dos ponteiros
        self.r_hor = LARG_TELA/2*R_HOR/100
        self.r_min = LARG_TELA/2*R_MIN/100
        self.r_seg = LARG_TELA/2*R_SEG/100

        # hora inicial
        self.t_hor = 9.0
        self.t_min = 15.0
        self.t_seg = 30.0

    def on_update(self, delta_time):
        self.t_seg += self.delta_seg
        if self.t_seg >= 60:
            self.t_seg = 0
            self.t_min += 1

        if self.t_min >= 60:
            self.t_min = 0
            self.t_hor += 1

        if self.t_hor >= 12:
            self.t_hor = 0

    def on_draw(self):
        ang_hor = 90 - 30*(
            self.t_hor +\
            self.t_min/60 +\
            self.t_seg/3600)
        ang_min = 90 - 6*(
            self.t_min +\
            self.t_seg/60)
        ang_seg = 90 - 6*self.t_seg

        xc = LARG_TELA/2
        yc = ALT_TELA/2

        x_hor = xc + self.r_hor*\
            math.cos(math.pi*ang_hor/180)
        y_hor = yc + self.r_hor*\
            math.sin(math.pi*ang_hor/180)

        x_min = xc + self.r_min*\
            math.cos(math.pi*ang_min/180)
        y_min = yc + self.r_min*\
            math.sin(math.pi*ang_min/180)

        x_seg = xc + self.r_seg*\
            math.cos(math.pi*ang_seg/180)
        y_seg = yc + self.r_seg*\
            math.sin(math.pi*ang_seg/180)

        arcade.start_render()
        arcade.draw_line(xc, yc, x_hor, y_hor,
            C_HOR, E_HOR)
        arcade.draw_line(xc, yc, x_min, y_min,
            C_MIN, E_MIN)
        arcade.draw_line(xc, yc, x_seg, y_seg,
            C_SEG, E_SEG)

def main():
    window = Relogio()
    arcade.run()

if __name__ == "__main__":
    main()
