
# modulo 04, ex 01
import arcade
import math

# raio dos ponteiros
R_HOR = 60
R_SEG = 90
R_MIN = 90
# espessura dos ponteiros
E_HOR = 20
E_MIN = 10
E_SEG = 1
# cor do ponteiros
C_HOR = arcade.color.WHITE
C_MIN = arcade.color.WHITE
C_SEG = arcade.color.RED

# FPS do relogio
FPS_RELOGIO = 5

# tamanho e titulo da janela que vamos usar
LARG_TELA = 600
ALT_TELA = 600
TIT_TELA = 'Relogio'

class Relogio(arcade.Window):
    def __init__(self):
        super().__init__(LARG_TELA, ALT_TELA,
            TIT_TELA)
        arcade.set_background_color(
            arcade.color.BLACK)
        # FPS
        self.set_update_rate(1/FPS_RELOGIO)
        # incremento do ponteiro dos segundos [s]
        self.delta_seg = 1/FPS_RELOGIO

        # meio da tela
        self.xc = LARG_TELA/2
        self.yc = ALT_TELA/2

        # arrays com as principais constantes
        # raio dos ponteiros
        self.raio = []
        self.raio.append(LARG_TELA/2*R_HOR/100)
        self.raio.append(LARG_TELA/2*R_MIN/100)
        self.raio.append(LARG_TELA/2*R_SEG/100)

        # cores
        self.cor = []
        self.cor.append(C_HOR)
        self.cor.append(C_MIN)
        self.cor.append(C_SEG)

        # espessura
        self.esp = []
        self.esp.append(E_HOR)
        self.esp.append(E_MIN)
        self.esp.append(E_SEG)

        # hora inicial
        self.t_hor = 9.0
        self.t_min = 15.0
        self.t_seg = 30.0

    def desenha_ponteiros(self):
        ang_drg = []
        ang_drg.append(90 - 30*(
            self.t_hor +\
            self.t_min/60 +\
            self.t_seg/3600))
        ang_drg.append(90 - 6*(
            self.t_min +\
            self.t_seg/60))
        ang_drg.append(90 - 6*self.t_seg)

        ang_rad = [math.pi*ang/180
            for ang in ang_drg]

        for i in range(3):
            x = self.xc + self.raio[i]*math.cos(ang_rad[i])
            y = self.yc + self.raio[i]*math.sin(ang_rad[i])
            arcade.draw_line(
                self.xc, self.yc,
                x, y,
                self.cor[i], self.esp[i])

    def on_update(self, delta_time):
        self.t_seg += self.delta_seg
        if self.t_seg >= 60:
            self.t_seg = 0
            self.t_min += 1

        if self.t_min >= 60:
            self.t_min = 0
            self.t_hor += 1

        if self.t_hor >= 12:
            self.t_hor = 0

    def on_draw(self):
        arcade.start_render()
        self.desenha_ponteiros()

def main():
    window = Relogio()
    arcade.run()

if __name__ == "__main__":
    main()
