import arcade
import random
import math
import os

MAX_ESCALA = 0.8

LARG_TELA = 300
ALT_TELA = 300
TIT_TELA = 'Bolinha'


class MeuJogo(arcade.Window):
    def __init__(self):
        super().__init__(LARG_TELA, ALT_TELA,
            TIT_TELA)            
        # muda o diretorio corrente para o mesmo
        # diretorio que esta o fonte .py
        file_path = os.path.dirname(
            os.path.abspath(__file__))
        os.chdir(file_path)
    
        arcade.set_background_color(
            arcade.color.WHITE)
        self.bola_list = arcade.SpriteList()

        arq = 'platformer-pack-redux-360-assets/PNG/Items/coinGold.png'
        x = 5
        for i in range(4):
            bola = arcade.Sprite(arq, MAX_ESCALA)
            bola.alpha = (i+1)*64 - 1
            bola.left = x
            x += bola.width/2
            bola.center_y = ALT_TELA / 2
            self.bola_list.append(bola)

    def on_update(self, delta_time):
        self.bola_list.update()
    
    def on_draw(self):
        arcade.start_render()
        for x in range(0, LARG_TELA, 10):
            arcade.draw_line(x, 0, x, ALT_TELA, arcade.color.BLACK)
        for y in range(0, ALT_TELA, 10):
            arcade.draw_line(0, y, LARG_TELA, y, arcade.color.BLACK)
        self.bola_list.draw()
    
def main():
    window = MeuJogo()
    arcade.run()

if __name__ == "__main__":
    main()
